<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <title-field
          v-bind="$attrs"
          required
          autofocus
          single-line
          :value="value"
          :min-length="2"
          v-on="$listeners"
          @input="emitValueToParent"
        />
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  import commonMessages from '../../commonMessages'
  import { showTheTitleHasAlreadyBeenTakenToast } from '@/services/api'

  export default {
    name: 'EditTitleDialog',
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
    },
    methods: {
      onSave (title) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('incomes/updateIncome', {
            ID: this.itemId,
            title,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(error => {
              const { status, data } = error.response
              if (status === this.$STATUS_CODE.UNPROCESSABLE_ENTITY) {
                const errorMessage = this.$t('incomeIsAlreadyRegisteredError', { title })
                showTheTitleHasAlreadyBeenTakenToast(data.errors.title[0], errorMessage)
              } else {
                this.$store.dispatch('toast/setOptions', {
                  variant: 'error',
                  text: this.$t('updateError'),
                })
              }
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateSuccess: 'Receita atualizada com sucesso!',
          updateError: 'Ops... Algo deu errado ao tentar atualizar a receita. Por favor, tente novamente.',
        },
        'en-US': {
          updateSuccess: 'Income successfully updated!',
          updateError: 'Oops... Something went wrong while trying to update the income. Please try again.',
        },
      },
      sharedMessages: commonMessages,
    },
  }
</script>
